<?php
namespace sms\qbsms;

use app\admin\lib\Plugin;


class QbsmsPlugin extends Plugin
{
    # 基础信息
    public $info = array(
        'name'        => 'Qbsms',//Demo插件英文名，改成你的插件英文就行了
        'title'       => '泉博智信',
        'description' => '泉博智信',
        'status'      => 1,
        'author'      => '泉博网络',
        'version'     => '1.0',
        'help_url'     => 'https://sms.quanbor.com/user',//申请接口地址
    );

    # 插件安装
    public function install()
    {
		//导入模板
		$smsTemplate= [];
		if (file_exists(__DIR__.'/config/smsTemplate.php')){
            $smsTemplate = require __DIR__.'/config/smsTemplate.php';
        }
		
        return $smsTemplate;
    }

    # 插件卸载
    public function uninstall()
    {
        return true;//卸载成功返回true，失败false
    }
	
	# 后台页面创建模板时可用参数
	public function description()
	{
		return file_get_contents(__DIR__.'/config/description.html');    
    } 
	
	#获取国内模板
	public function getCnTemplate($params)
	{				
		$data['status']='success';
		$data['template']['template_status']=2;
		return $data;
	}
	#创建国内模板
	public function createCnTemplate($params)
	{
		$data['status']='success';
		$data['template']['template_status']=2;
		return $data;
	}
	#修改国内模板
	public function putCnTemplate($params)
	{
		$data['status']='success';
		$data['template']['template_status']=2;
		return $data;
	}
	#删除国内模板
	public function deleteCnTemplate($params)
	{
		$data['status']='success';
		return $data;
	}
	#发送国内短信
    public function sendCnSms($params)
    {	   	
        
        $param['templateParam']=$params['templateParam'];
		$param['mobile']=trim($params['mobile']);
		$param['template_id']=trim($params['template_id']);
        $resultTemplate= $this->APIHttpRequestCURL('cn',$param,$params['config']);
		if($resultTemplate['status']=="success"){
			$data['status']="success";
			$data['content']=$content;
		}else{
			$data['status']="error";
			$data['content']=$content;
			$data['msg']=$resultTemplate['msg'];
		}
		return $data;
    }	
	# 以下函数名自定义

	private function APIHttpRequestCURL($sms_type='cn',$params,$config){
		
		if($sms_type=='cn'){
			$url='https://www.smspt.cn';
		}else if($sms_type=="global"){
			$url='https://www.smspt.cn';
		}
        $userId=$config['user']; //用户ID
        $password=$config['pass']; //用户密码
        $phone=$params['mobile']; //要发送的手机号，多个手机号使用英文逗号分隔
        $signName=$config['sign']; //签名ID
        $tempId=$params['template_id']; //模板ID
        
        foreach ($params['templateParam'] as $key => $para) {
            $arr[$key]=$para;
        }
        
        $varParam=json_encode($arr);
        $varParam=base64_encode($varParam); //将json转换为base64编码
        $source_id=$config['source_id']; //渠道ID
        $time=time(); //时间戳
        $sign=md5($userId.md5($password).$tempId.$signName.$time.$source_id); //计算签名
        $data="userId={$userId}&phone={$phone}&tempId={$tempId}&signName={$signName}&timeStamp={$time}&varParam={$varParam}&sign={$sign}&source_id={$source_id}"; //拼接待提交数据
        // var_dump($url.'/sms/api_v1.php?mod=sendMessageGroup',$data);
        $result=$this->curl_request($url.'/sms/api_v1.php?mod=sendMessageGroup',$data); 
        $result=json_decode($result,true);
        if ($result['code']  == '1') {
            return array('status' => "success", 'msg' => $result['msg']);
        } else {
            return array('status' => "error", 'msg' => $result['msg'] . '. Code: ' . $result['code']);
        }
    }

        /**
     * 使用CURL进行HTTP请求
     * 参数1：访问的URL，
     * 参数2：post数据(不填则为GET)，
     * 参数3：提交的$cookies,
     * 参数4：是否返回$cookies
     */
    private function curl_request($url, $post = '', $cookie = '', $returnCookie = 0, $httpHeader=[]){
        $curl = curl_init();
        
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_USERAGENT, 'Mozilla/5.0 (compatible; MSIE 10.0; Windows NT 6.1; Trident/6.0)');
        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($curl, CURLOPT_AUTOREFERER, 1);
        // curl_setopt($curl, CURLOPT_REFERER, "http://XXX");
        
        if ($post) {
            curl_setopt($curl, CURLOPT_POST, 1);
            curl_setopt($curl, CURLOPT_POSTFIELDS, $post);
        }
        if ($cookie) {
            curl_setopt($curl, CURLOPT_COOKIE, $cookie);
        }
        
        curl_setopt($curl, CURLOPT_HTTPHEADER, $httpHeader);
        curl_setopt($curl, CURLOPT_HEADER, $returnCookie);
        curl_setopt($curl, CURLOPT_TIMEOUT, 60);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
        $data = curl_exec($curl);
        if (curl_errno($curl)) {
            return '';
        }
        curl_close($curl);
        
        if ($returnCookie) {
            list($header, $body) = explode("\r\n\r\n", $data, 2);
            preg_match_all("/Set\-Cookie:([^;]*);/", $header, $matches);
            $info['cookie'] = substr($matches[1][0], 1);
            $info['content'] = $body;
            return $info;
        } else {
            return $data;
        }
    }
}